/*********************************************************************/
/* File: buffer.h                                   Date 4/7 -98     */
/* Based on popproxy version 1.3 by N.Oren                           */
/* Programmer: Jens Landgr                                          */
/*********************************************************************/

#ifndef BUFFER_DEF
#define BUFFER_DEF

#include <string.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

class bufferClass
{
private:
  int _size;
  char *_buf;
  char *_tail;

  int getline(char *buf);
protected:
  int _file;
public:
  bufferClass(int size);
  virtual int readl(char *data);
  virtual int writel(const char *data);
  virtual void flush() { fsync(_file); }
  virtual ~bufferClass();
};

class sockbufferClass: public bufferClass
{
public:
  sockbufferClass(int sock, int size);
//  int readl(char *data);
//  int writel(const char *data);
  ~sockbufferClass();
};

class procbufferClass: public bufferClass
{
public:
  procbufferClass(const char *command, int size);
//  int readl(char *data);
//  int writel(const char *data);
  ~procbufferClass();
};

#endif
