/*********************************************************************/
/* File: wgpopp.h                                   Date 4/7 -98     */
/* Based on popproxy version 1.3 by N.Oren                           */
/* Programmer: Jens Landgr                                          */
/* History:                                                          */
/* 12/8 -98   Defined DEBUG and DEBUG_MESS etc. to optimize the      */
/*            compiled no-need-to-debug version of the program.      */ 
/*********************************************************************/

#include "buffer.h"
#include <ctype.h>
#include <signal.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <time.h>
#include <fcntl.h>
#include <unistd.h>
#include <netdb.h>
#include <syslog.h>

/* what port mail hub listens on */
#define HUBPORT 110		

/* # of seconds till timeout when waiting for data */
#define TIMEOUT 60

/* The separator between username and mailhubname */
#define SEP_SYMBOL '#'

/* The maximum length of a username */
#define MAXUNAME 15

/* The maximum length of a server name */
#define MAXSERVNAME 40

#ifndef PROGRAM_NAME
#define PROGRAM_NAME "wgpopp"
#endif

/* The first signal-message sent by this program (to identify it). */
#define FIRSTSIGNAL "Pop3 proxy server (" PROGRAM_NAME ") at Allanon starting."

/* The responce signal to send on AUTH */
#define AUTH_SIG C_ERR

/* The responce on the AUTH-signal, many servers (and programs) have 
   problems with this. */
#define AUTH_RESPONCE "NO"

/* What to return on normal exit. */
#define NORMAL_EXIT 0

/* What to return on abnormal exit. */
#define ABNORMAL_EXIT -1

/* How to start popper */
//#define POPPER_COMLINE "/usr/sbin/popper"

/* Service name for popper */
#define POPPERSERVICE "pop2"

/* Service protocol for popper */
#define POPPERPROT "tcp"

/* The name of the localhost */
#define LOCALHOST "localhost"

/* Used in many parts of this program. */
extern void panic(const char *, ...);

#ifdef DEBUG

/* Different debug levels */
#define BASIC_DEBUG 1
#define IO_DEBUG 2
#define TM_DEBUG 3

#define set_alarm(time) if (debug < TM_DEBUG) alarm(time)
#define DEBUG_MESS(params) if (debug) syslog params 
extern int debug;

#else

#define set_alarm alarm
#define DEBUG_MESS(a)

#endif

